##########################################################################
#Ή̂ȂgQ̔䗦Ɋւ铝vIig2zj
#
#x: (g̃xNg)
#n: xkCs(g̃xNg)
#prob=c(0.025, 0.05, 0.5, 0.95, 0.975): 㕪zŕ񍐂m_
#see=1234,cha=5,war=1000,ite=21000 : MCMC֘Ãp^
#o
#fit:stan̏o, par:ꐔXg, prob:mxNg, 
#p: 䗦(2)
#xaste: \zx*(2)
#U2: s̕䗦̕䗦傫Ƃ1AȊO0 (,g*g)
#log_lik;ΐޓx
##########################################################################
Bi03 <- function(x,n,prob=c(0.025, 0.05, 0.5, 0.95, 0.975),
                 see=1234, cha=5, war=1000, ite=21000, fi=NA)
{
   library(rstan)
   g <- length(x)
   dat <- list(g=g,x=x,n=n)
   scr <- "stan/Bi03.stan"                                # Stant@C
   par<-c("p","xaste","U2","log_lik")                     # samplingϐ
   fit<-stan(file=scr,data=dat,pars=par,
             seed=see,chains=cha,warmup=war,iter=ite, fit=fi)
   ext<-extract(fit,par);
   out<-list(fit=fit,par=par,prob=prob,
             p=ext$p, xaste=ext$xaste, U2=ext$U2, log_lik=ext$log_lik);
   class(out)<-'Bi03'
   return(invisible(out))
}
##########################################################################
#̃\bh
#
#x:NX 'Bi03'̃IuWFNg
#degits=3 : ̊ۂ
##########################################################################
print.Bi03<-function(x,degits=3)
{
   log_lik<-x$log_lik; p<-x$p; xaste<-x$xaste; U2<-x$U2; 
   waic<- (-2)*(log(mean(exp(log_lik)))) + 2*(var(log_lik))
   print(x$fit,pars=x$par,digits_summary=degits,probs=x$prob)
   print(paste("waic=",round(waic,degits),sep=""))
   out<-list(waic=waic)
   return(invisible(out))
}  
