##########################################################################
#JeSk̔䗦̓vI
#
#x: (k̃xNg)
#prob=c(0.025, 0.05, 0.5, 0.95, 0.975): 㕪zŕ񍐂m_
#see=1234,cha=5,war=1000,ite=21000 : MCMC֘Ãp^
#o
#fit:stan̏o, par:ꐔXg, prob:mxNg, 
#pi: 䗦(k)
#U2: s̕䗦̕䗦傫Ƃ1AȊO0 (,k*k)
#log_lik;ΐޓx
##########################################################################
Mu01 <- function(x,prob=c(0.025, 0.05, 0.5, 0.95, 0.975),
                 see=1234, cha=5, war=1000, ite=21000, fi=NA)
{
   library(rstan)
   k <- length(x)
   dat <- list(k=k,x=x)
   scr <- "stan/Mu01.stan"                         # Stant@C
   par<-c("pi","U2","log_lik")                     # samplingϐ
   fit<-stan(file=scr,data=dat,pars=par,
             seed=see,chains=cha,warmup=war,iter=ite, fit=fi)
   ext<-extract(fit,par);
   out<-list(fit=fit,par=par,prob=prob,
             pi=ext$p, U2=ext$U2, log_lik=ext$log_lik);
   class(out)<-'Mu01'
   return(invisible(out))
}
##########################################################################
#̃\bh
#
#x:NX 'Mu01'̃IuWFNg
#degits=3 : ̊ۂ
##########################################################################
print.Mu01<-function(x,degits=3)
{
   log_lik<-x$log_lik; 
   waic<- (-2)*(log(mean(exp(log_lik)))) + 2*(var(log_lik))
   print(x$fit,pars=x$par,digits_summary=degits,probs=x$prob)
   print(paste("waic=",round(waic,degits),sep=""))
   out<-list(waic=waic)
   return(invisible(out))
}  
